opal/util/show_help.h File Reference.TH "opal/util/show_help.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/show_help.h \- The 'show help' subsystem (SHS) in Open MPI is intended to help the developer convey meaningful information to the user (read longer than is convenient in a single printf), particularly when errors occur. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <stdarg.h>\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_show_help\fP (const char *filename, const char *topic, bool want_error_header,...)"
.br
.RI "\fILook up a text message in a text file and display it to the stderr using printf()-like substitutions (d, s, etc.). \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_show_help_finish_parsing\fP (void)"
.br
.in -1c
.SH "Detailed Description"
.PP 
The 'show help' subsystem (SHS) in Open MPI is intended to help the developer convey meaningful information to the user (read longer than is convenient in a single printf), particularly when errors occur. 

The SHS allows the storage of arbitrary-length help messages in text files which can be parameterized by text filename, message name, POSIX locale, and printf()-style parameters (e.g., '%s', '%d', etc.). Note that the primary purpose of the SHS is to display help messages, but it can actually be used to display any arbitrary text messages.
.PP
The function \fBopal_show_help()\fP is used to find a help message and display it. Its important parameters are a filename, message name, and printf()-style varargs parameters used to substitute into the message.
.PP
There's work pending about i18n-like support (nothing near as complex as GNU gettext -- just a simple mechanism that may be used). But I won't describe it here until/if it's actually used. So right now, the file lookup is quite straightforward -- the caller passes in the filename to find the help message, and the SHS looks for that file in $pkgdatadir (typically $prefix/share/openmpi).
.PP
Once the file is successfully opened, the SHS looks for the appropriate help message to display. It looks for the message name in the file, reads in the message, and displays it. printf()-like substitutions are performed (e.g., d, s, etc.) -- \fBopal_show_help()\fP takes a variable legnth argument list that are used for these substitutions.
.PP
The format of the help file is simplistic:
.PP
.IP "\(bu" 2
Comments begin with #. Any characters after a # on a line are ignored. It is not possible to escape a #.
.IP "\(bu" 2
Message names are on a line by themselves and marked with []. Names can be any ASCII string within the [] (excluding the characters newline, linefeed, [, ], and #).
.IP "\(bu" 2
Messages are any characters between message names and/or the end of the file.
.PP
.PP
Here's a sample helpfile:
.PP
# This is a comment. [topic 1] Here's the first message. Let's substitute in an integer: d. The quick brown fox jumped over the lazy s. # This is another comment -- it's not displayed in the first message. [another:topic:foo:foo:foo] This is the second message. Let's just keep rolling along to get to the second line in the message for this example. 
.PP
It is expected that help messages will be grouped by filename; similar messages should be in a single file. For example, an MCA component may install its own helpfile in Open MPI's $pkgdatadir, and therefore the component can invoke \fBopal_show_help()\fP to display its own help messages.
.PP
Message files in $pkgdatadir have a naming convention: they generally start with the prefix 'help-' and are followed by a name descriptive of what kind of messages they contain. MCA components should generally abide by the MCA prefix rule, with the exception that they should start the filename with 'help-', as mentioned previously.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int opal_show_help (const char * filename, const char * topic, bool want_error_header,  ...)"
.PP
Look up a text message in a text file and display it to the stderr using printf()-like substitutions (d, s, etc.). 
.PP
\fBParameters:\fP
.RS 4
\fIfilename\fP File where the text messages are contained. 
.br
\fItopic\fP String index of which message to display from the text file. 
.br
\fIwant_error_header\fP Display error-bar line header and footer with the message. 
.br
\fIvarargs\fP Any additional parameters are substituted, printf()-style into the help message that is displayed.
.RE
.PP
This function looks for the filename in the $pkgdatadir (typically $prefix/share/openmpi), and looks up the message based on the topic, and displays it. If want_error_header is true, a header and footer of asterisks are also displayed. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
